#ifndef _user_api_h_
#define _user_api_h_

// On the palm, this modifier won't work
#define rom

// On the palm, need a way to interrupt the vex program
int VexRunning( void );
void MakeSound(signed long frequency, unsigned short milliseconds);
int TestSerial( void );
void RunProgram(unsigned char prognum);
unsigned char ReadUltrasonic(unsigned char ucInterruptNum, unsigned char ucOutputNum);
void SetMotors( unsigned char ucValue1, unsigned char ucValue2);
 
unsigned char GetDigitalInput(unsigned char ucNum);
void SetDigitalOutput(unsigned char ucNum, unsigned char ucValue);

unsigned int GetAnalogInput(unsigned char ucNum);
void SetMotor(unsigned char ucNum, unsigned char ucValue);
void SetServo(unsigned char ucNum, unsigned char ucValue);
void SetPWM(unsigned char ucNum, unsigned char ucValue);

void StartEncoder(unsigned char ucEncNum);
void PresetEncoder(unsigned char ucEncNum, unsigned long lValue);
unsigned long GetEncoder(unsigned char ucEncNum);
void StopEncoder(unsigned char ucEncNum);

void StartUltrasonic(unsigned char ucInterruptNum, unsigned char ucOutputNum);
unsigned char GetUltrasonic(unsigned char ucInterruptNum, unsigned char ucOutputNum);
void StopUltrasonic(unsigned char ucInterruptNum, unsigned char ucOutputNum);

void StartTimer(unsigned char ucTimerNum);
void PresetTimer(unsigned char ucTimerNum, unsigned long lValue);
unsigned long GetTimer(unsigned char ucTimerNum);
void StopTimer(unsigned char ucTimerNum);

void Wait(long unsigned int lWait);
unsigned char WaitB(long unsigned int lWait, unsigned char *bumpers);

void Arcade2(unsigned char ucRx, 
			 unsigned char ucChannelMove, unsigned char ucChannelRotate,
             unsigned char ucMotorLeft, unsigned char ucMotorRight,
			 unsigned char ucMotorLeftInv, unsigned char ucMotorRightInv);

void Arcade4(unsigned char ucRx, 
			 unsigned char ucChannelMove, unsigned char ucChannelRotate,
             unsigned char ucMotorLeftFront, unsigned char ucMotorRightFront,
			 unsigned char ucMotorLeftRear, unsigned char ucMotorRightRear,
			 unsigned char ucMotorLeftFrontInv, unsigned char ucMotorRightFrontInv,
			 unsigned char ucMotorLeftRearInv, unsigned char ucMotorRightRearInv);

void Tank2(unsigned char ucRx, 
		   unsigned char ucChannelLeft, unsigned char ucChannelRight,
           unsigned char ucMotorLeft, unsigned char ucMotorRight,
		   unsigned char ucMotorLeftInv, unsigned char ucMotorRightInv);

void Tank4(unsigned char ucRx, 
		   unsigned char ucChannelLeft, unsigned char ucChannelRight,
           unsigned char ucMotorLeftFront, unsigned char ucMotorRightFront,
		   unsigned char ucMotorLeftRear, unsigned char ucMotorRightRear,
		   unsigned char ucMotorLeftFrontInv, unsigned char ucMotorRightFrontInv,
		   unsigned char ucMotorLeftRearInv, unsigned char ucMotorRightRearInv);

void MotorRcControl(unsigned char ucRx, unsigned char ucChannel, unsigned char ucMotor, unsigned char ucInv);

void ServoRcControl(unsigned char ucRx, unsigned char ucChannel, unsigned char ucMotor, unsigned char ucInv);

unsigned char GetRxInput(unsigned char ucRx, unsigned char ucChannel);

void DefineControllerIO(unsigned char ucNumberOfAnalogChannels,
						unsigned char ucIO1, unsigned char ucIO2, unsigned char ucIO3, unsigned char ucIO4, 
						unsigned char ucIO5, unsigned char ucIO6, unsigned char ucIO7, unsigned char ucIO8, 
						unsigned char ucIO9, unsigned char ucIO10,unsigned char ucIO11,unsigned char ucIO12, 
						unsigned char ucIO13,unsigned char ucIO14,unsigned char ucIO15,unsigned char ucIO16);


void CheckForViolations(unsigned char *ucError, unsigned char *ucWarning);

int PrintToScreen(rom const char *szFormat, ...);
int printf(rom const char *format, ...);

#endif // _user_api_h_
